package com.book.shop.dao;

import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

/**
 * Ĳݿ࣬ݿ󶼽̳Щ
 * @version 1.0
 */
public class BaseDao {
	protected  Connection conn;
	private Statement stmt;
	private ResultSet rs;
	
	public void initConnection(){
		BaseConnection baseConn = BaseConnection.getInstance();
		conn = baseConn.getConnection();
	}
	
	/**
	 * һ¼
	 * @param obj Ҫӵݿ
	 * @param table_name	Ҫݵݿ
	 * @return Ƿӳɹtrueʾӳɹfalseʾʧ
	 */
	public boolean add(Object obj, String table_name) {
		boolean result =false;
		try {
			//ƴsql
			String sql = "insert into " + table_name + " (";
			sql += this.getFields(obj);
			sql += ") values (";
			sql += this.getValues(obj);
			sql += ")";
			int count = this.executeUpdate(sql);	//ִSQL
			if(count > 0)
				result = true;
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		return result;
	}
	/**
	 * ޸ݿ
	 * @param obj Ҫ޸ĵ
	 * @param table_name  Ҫ޸ĵı
	 * @return Ƿ޸ĳɹ trueΪɹ falseΪʧ
	 */
	public boolean update(Object obj, String table_name){
		boolean result = false;
		try {
			String sql = "update " + table_name;
			Field fields[] = obj.getClass().getDeclaredFields();		//ȡObjectֶ
			Field idField = null;
			for(int i = 0; i < fields.length; i++){		//ƴӲ
				Field field = fields[i];		//õiֶ
				field.setAccessible(true);		//ǰֶΪpublic
				if("id".equals(field.getName())){	//жϵǰֶǷIDIDֵԶSQLƴ
					sql +=  field.getName() + " = '" + field.get(obj) + "'";		//ֶƣƴsql
					if(i > 0 && i < fields.length - 1 ){
						sql += ",";
					}
					
				}else{
					idField = field;
					if(i == fields.length - 1){
						sql += " where id = " + idField.get(obj);
					}
				}
			}
			int count = this.executeUpdate(sql);
			if(count > 0)
				result = true;
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		return result;
	}
	/**
	 * رݿ
	 * @param con
	 * @param stmt
	 * @param rs
	 */
	public void close(Connection con,Statement stmt, ResultSet rs){
		try {
			if(!con.isClosed()){		//жݿǷر
				if(rs != null)
					rs.close();
				stmt.close();
				con.close();
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	/**
	 * ݿɾĶɵø÷
	 * @param sqlҪִеSQL
	 * @return ظӰ0ʾִʧ
	 * @throws SQLException
	 */
	public int executeUpdate(String sql) throws SQLException{
		this.initConnection();
		this.stmt = conn.createStatement();
		int count = this.stmt.executeUpdate(sql);
		return count;
	}
	/**
	 * Objectֶƴӳַ
	 * @param obj
	 * @return ƴӺַ
	 */
	private String getFields(Object obj){
		String sql = "";
		Field fields[] = obj.getClass().getDeclaredFields();		//ȡObjectֶ
		for(int i = 0; i < fields.length; i++){		//ƴӲ
			Field field = fields[i];		//õiֶ
			field.setAccessible(true);		//ǰֶΪpublic
			if("id".equals(field.getName())){	//жϵǰֶǷIDIDֵԶSQLƴ
				sql +=  field.getName() ;		//ֶƣƴsql
				if(i > 0 && i < fields.length - 1 ){
					sql += ",";
				}
				
			}
		}
		return sql;
	}
	/**
	 * Objectֵֶƴӳַ
	 * @param obj
	 * @return ƴӺַ
	 * @throws IllegalArgumentException
	 * @throws IllegalAccessException
	 */
	private String getValues(Object obj) throws IllegalArgumentException, IllegalAccessException{
		String sql = "";
		Field fields[] = obj.getClass().getDeclaredFields();		//ȡObjectֶ
		for(int i = 0; i < fields.length; i++){		//ƴӲ
			Field field = fields[i];		//õiֶ
			field.setAccessible(true);		//ǰֶΪpublic
			if("id".equals(field.getName())){	//жϵǰֶǷIDIDֵԶSQLƴ
				sql += "'" + field.get(obj) + "'";		//ֶεֵƴsql
				if(i > 0 && i < fields.length - 1 ){
					sql += ",";
				}
				
			}
		}
		return sql;
	}
	/**
	 * IDѯĳ¼
	 * @param id ҪѯID
	 * @param table_name Ҫѯݿ
	 * @param cls	ҪյĶClass
	 * @return طװĶ
	 */
	public Object queryForObject(int id, String table_name, Class cls){
		Object obj = null;
		try {
			this.initConnection();
			obj = this.getObject(cls);
			this.stmt = this.conn.createStatement();
			String sql = "select * from " + table_name + " where id = " + id;
			this.rs = this.stmt.executeQuery(sql);
			if(rs.next()){
				Field fields[] = obj.getClass().getDeclaredFields();
				for(Field field : fields){
					field.setAccessible(true);
					field.set(obj, rs.getObject(field.getName()));		//Եǰÿֶθֵ
				}
			}
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		return obj;
	}
	/**
	 * ѯм¼
	 * @param table_name Ҫѯı
	 * @param cls	ҪյĶClass
	 * @return ж󼯺
	 */
	public List queryAllList(String table_name, Class cls){
		List datas = new ArrayList();
		try {
			this.initConnection();
			String sql = "select * from " + table_name;
			this.stmt = this.conn.createStatement();
			this.rs = this.stmt.executeQuery(sql);
			while(rs.next()){
				Object obj = this.getObject(cls);
				Field fields[] = obj.getClass().getDeclaredFields();
				for(Field field : fields){
					field.setAccessible(true);
					field.set(obj, rs.getObject(field.getName()));		//Եǰÿֶθֵ
				}
				datas.add(obj);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		
		return datas;
	}
	/**
	 * whereӾѯзϼ¼ݼ
	 * @param where whereӾ
	 * @param table_name Ҫѯݿ
	 * @param cls ҪյĶClass
	 * @return طϽĽ
	 */
	public List queryByWhereList(String where, String table_name, Class cls){
		List datas = new ArrayList();
		try {
			this.initConnection();
			String sql = "select * from " + table_name + " where " + where; 
			this.stmt = this.conn.createStatement();
			this.rs = this.stmt.executeQuery(sql);
			while(rs.next()){
				Object obj = this.getObject(cls);
				Field fields[] = obj.getClass().getDeclaredFields();
				for(Field field : fields){
					field.setAccessible(true);
					field.set(obj, rs.getObject(field.getName()));		//Եǰÿֶθֵ
				}
				datas.add(obj);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		
		return datas;
	}
	/**
	 * IDɾĳ¼
	 * @param table_name	Ҫɾݿ
	 * @param id  Ҫɾļ¼ID
	 * @return Ƿɾɹ trueʾɾɹfalseʾɾʧ
	 */
	public boolean remove(String table_name,Integer id){
		boolean result = false;
		try {
			this.initConnection();
			String sql = "delete from " + table_name + " where id = " + id;
			int count = this.executeUpdate(sql);
			if(count > 0)
				result = true;
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		return result;
	}
	/**
	 * ɾָݿм¼
	 * @param table_name Ҫɾݿ
	 * @return	Ƿɾɹtrueʾɾɹfalseʾɾʧ
	 */
	public boolean removeAll(String table_name){
		boolean result = false;
		try {
			this.initConnection();
			String sql = "TRUNCATE TABLE " + table_name;
			int count = this.executeUpdate(sql);
			if(count > 0)
				result = true;
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			this.close(conn, stmt, rs);
		}
		return result;
	}
	
	private Object getObject(Class cls) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
		Class c = Class.forName(cls.getName());
		Object obj = c.newInstance();
		return obj;
	}
}


